# ACE_Asynch_Read_File_Impl Class Reference

Abstract base class for all the concrete implementation classes that provide different implementations for the ACE_Asynch_Read_File::Result. More...

`#include <Asynch_IO_Impl.h>`

Inheritance diagram for ACE_Asynch_Read_File_Impl:

[legend]
Collaboration diagram for ACE_Asynch_Read_File_Impl:

[legend]
List of all members.

## Public Member Functions

virtual | ~ACE_Asynch_Read_File_Impl (void)
virtual int | read (ACE_Message_Block &message_block, size_t bytes_to_read, u_long offset, u_long offset_high, const void *act, int priority, int signal_number)=0
virtual int | readv (ACE_Message_Block &message_block, size_t bytes_to_read, u_long offset, u_long offset_high, const void *act, int priority, int signal_number)=0
virtual int | read (ACE_Message_Block &message_block, size_t bytes_to_read, const void *act, int priority, int signal_number)=0
virtual int | readv (ACE_Message_Block &message_block, size_t bytes_to_read, const void *act, int priority, int signal_number)=0

## Protected Member Functions

| ACE_Asynch_Read_File_Impl (void)
| Do-nothing constructor.

## Detailed Description

Abstract base class for all the concrete implementation classes that provide different implementations for the ACE_Asynch_Read_File::Result.

## Constructor & Destructor Documentation

ACE_Asynch_Read_File_Impl::~ACE_Asynch_Read_File_Impl | ( | void |  | ) | `[virtual]`

ACE_INLINE ACE_Asynch_Read_File_Impl::ACE_Asynch_Read_File_Impl | ( | void |  | ) | `[protected]`

| Do-nothing constructor.

## Member Function Documentation

virtual int ACE_Asynch_Read_File_Impl::read | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[pure virtual]`

| This starts off an asynchronous read. Upto <bytes_to_read> will be read and stored in the <message_block>. Implements ACE_Asynch_Read_Stream_Impl. Implemented in ACE_POSIX_Asynch_Read_File, and ACE_WIN32_Asynch_Read_File.

virtual int ACE_Asynch_Read_File_Impl::read | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | u_long | offset,
|  | u_long | offset_high,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[pure virtual]`

| This starts off an asynchronous read. Upto <bytes_to_read> will be read and stored in the <message_block>. The read will start at <offset> from the beginning of the file. Implemented in ACE_POSIX_Asynch_Read_File, and ACE_WIN32_Asynch_Read_File.

virtual int ACE_Asynch_Read_File_Impl::readv | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[pure virtual]`

| Same as above but with scatter support, through chaining of composite message blocks using the continuation field. Implements ACE_Asynch_Read_Stream_Impl. Implemented in ACE_WIN32_Asynch_Read_File.

virtual int ACE_Asynch_Read_File_Impl::readv | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | u_long | offset,
|  | u_long | offset_high,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[pure virtual]`

Same as above but with scatter support, through chaining of composite message blocks using the continuation field.

Note:
  In win32 Each data block payload must be at least the size of a system memory page and must be aligned on a system memory page size boundary

Implemented in ACE_WIN32_Asynch_Read_File.

The documentation for this class was generated from the following files:

- Asynch_IO_Impl.h
- Asynch_IO_Impl.cpp
- Asynch_IO_Impl.inl